#! /usr/bin/perl

#---parse the request header------------------------------------#


read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});

@pairs = split(/&/, $buffer);

foreach $pair (@pairs) {
    ($name, $value) = split(/=/, $pair);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $FORM{$name} = $value;

}

#------------Check the database for existance of the user---------------------#
use DBI;
# Read in configuration
my $path = ""; # With a slash at the end
use vars qw(%config);
undef %config;
local %config = ();
do "${path}config/config.cgi";

# Open DBH handle
$dbh=DBI->connect("dbi:mysql:" .
                $config{database} . ':' . $config{hostname},
                $config{username},
                $config{password});


if (!$dbh)
{
print "Couldn't contact the Mysql engine... database is down or does not exist.\n";
exit;
}

$sql="";

$sql = $dbh->prepare("select AdminId from Administrator where AdminName='$FORM{'aname'}'");
$sql->execute();


if (!$sql)
{
print "Syntax error in SQL query.\n";
exit;
}

$row = $sql->fetchrow_array();

#print $row;
#exit; 

#------------If Administrator not found direct him to Login page-----------------#

if ($row eq "")
{
	print "Content-Type: text/html\n\n";
	
	print "<html>\n";
	print "<head>\n";
	print "<title></title>\n";
	print "</head>\n";
	print "<body>\n";
	print "<center>\n";
	print "<h1><u>You are 'not' a Administrator</u></h1>\n"; 
	print "<a href=\"./adminlogin.cgi\">Back</a>\n";
	print "</center>\n";
	print "</body>\n";
	print "</html>\n";
	
exit;
}

$aid = $row;
#print $aid;
#exit;


#-----------else if Administrator found check his password-----------------------------#
$sql1 = $dbh->prepare("select AdminId from Administrator where AdminName='$FORM{'aname'}' and Passwd='$FORM{'passwd'}'");
$sql1->execute();
if (!$sql1)
{
print "Syntax error in SQL query.\n";
exit;
}

$row = $sql1->fetchrow_array();








#--------------if password is incorrect redirect to login page-------------#

if ($row eq "")
{
print "Content-Type: text/html\n\n";	
	
	print "<html>\n";
	print "<head>\n";
	print "<title>Wrong password</title>\n";
	print "</head>\n";
	print "<body>\n";
	print "<center>\n";
	print "<h1><u>Wrong Password</u></h1>\n"; 
	print "<a href=\"javascript:history.back()\">Try Again?</a>\n";
	print "</center>\n";
	print "</body>\n";
	print "</html>\n";
	
exit;
}

#---------------If Administrator exists then create a new session for the Administrator--------#

print "Set-Cookie: adminid=$FORM{'aname'}; \n";
print "Content-Type: text/html\n\n";


print "<html>\n";
print "<body>\n";

print "<script language=javascript>\n";
print "location=\"./adminhomepage1.cgi\" \n";
print "</script>\n";

print "</body>\n";
print "</html>\n";

$dbh->disconnect();
