# MySQL dump 8.13
#
# Host: ssprofile.com    Database: ssprofile
#--------------------------------------------------------
# Server version	3.22.32

#
# Table structure for table 'Administrator'
#

CREATE TABLE Administrator (
  AdminId int(11) DEFAULT '0' NOT NULL auto_increment,
  AdminName varchar(50) DEFAULT '' NOT NULL,
  Passwd varchar(50) DEFAULT '' NOT NULL,
  JoinDate date DEFAULT '0000-00-00' NOT NULL,
  PRIMARY KEY (AdminId)
);

#
# Dumping data for table 'Administrator'
#

INSERT INTO Administrator VALUES (1,'administrator','admin123','2002-06-06');

#
# Table structure for table 'Cookies'
#

CREATE TABLE Cookies (
  CookieId bigint(50) DEFAULT '0' NOT NULL,
  UserId int(50) DEFAULT '0' NOT NULL,
  LAT bigint(60) DEFAULT '0' NOT NULL,
  PRIMARY KEY (CookieId)
);

#
# Table structure for table 'Sites'
#

CREATE TABLE Sites (
  UserId int(11) DEFAULT '0' NOT NULL,
  SiteName varchar(50) DEFAULT '' NOT NULL,
  Url varchar(100) DEFAULT '' NOT NULL,
  Hits int(11) DEFAULT '0' NOT NULL,
  Credits double(10,0) DEFAULT '0' NOT NULL,
  State enum('Enabled','Disabled','Waiting','On Hold') DEFAULT 'Waiting' NOT NULL,
  Language varchar(50) DEFAULT '' NOT NULL,
  PRIMARY KEY (Url)
);

#
# Dumping data for table 'Sites'
#

INSERT INTO Sites VALUES (1,'yigle.com','http://www.yigle.com',92,2598,'Enabled','English');
INSERT INTO Sites VALUES (1,'rediff.com','http://rediff.com',77,1,'Enabled','English');
INSERT INTO Sites VALUES (1,'google.com','http://google.com',71,1,'Enabled','English');

#
# Table structure for table 'Users'
#

CREATE TABLE Users (
  UserId int(11) DEFAULT '0' NOT NULL auto_increment,
  UserName varchar(60) DEFAULT '' NOT NULL,
  Password varchar(60) DEFAULT '' NOT NULL,
  Email varchar(50) DEFAULT '' NOT NULL,
  Credits int(11) DEFAULT '0' NOT NULL,
  JoinDate date DEFAULT '0000-00-00' NOT NULL,
  loggedin enum('True','False') DEFAULT 'False' NOT NULL,
  IntroducerId int(11) DEFAULT '0' NOT NULL,
  no_refered int(11) DEFAULT '0' NOT NULL,
  credits_from_ref int(11) DEFAULT '0' NOT NULL,
  crcheck int(11) DEFAULT '0',
  PRIMARY KEY (UserId)
);

#
# Table structure for table 'admin'
#

CREATE TABLE admin (
  user_id varchar(50),
  address varchar(50)
);

#
# Table structure for table 'fbfeedback'
#

CREATE TABLE fbfeedback (
  fbid int(11) DEFAULT '0' NOT NULL auto_increment,
  useridlocal varchar(50) DEFAULT '' NOT NULL,
  sitename varchar(50) DEFAULT '' NOT NULL,
  fburl varchar(100) DEFAULT '' NOT NULL,
  siteuid varchar(50) DEFAULT '' NOT NULL,
  sitepwd varchar(50) DEFAULT '' NOT NULL,
  PRIMARY KEY (fbid)
);

#
# Table structure for table 'fbusers'
#

CREATE TABLE fbusers (
  userid varchar(50) DEFAULT '' NOT NULL,
  password varchar(50) DEFAULT '' NOT NULL,
  username varchar(50) DEFAULT '' NOT NULL,
  PRIMARY KEY (userid)
);

#
# Table structure for table 'graphs'
#

CREATE TABLE graphs (
  userid int(11) DEFAULT '0' NOT NULL,
  gdate date DEFAULT '0000-00-00' NOT NULL,
  hits int(11) DEFAULT '0' NOT NULL,
  credits int(11) DEFAULT '0' NOT NULL,
  PRIMARY KEY (userid,gdate)
);

#
# Table structure for table 'specs'
#

CREATE TABLE specs (
  Time int(11) DEFAULT '0' NOT NULL,
  Credits_inc int(11) DEFAULT '0' NOT NULL,
  Credits_dec int(11) DEFAULT '0' NOT NULL,
  timeout int(2) DEFAULT '2' NOT NULL,
  immediate_ref_cr int(11) DEFAULT '1' NOT NULL,
  percent_cr int(11) DEFAULT '5' NOT NULL
);

#
# Dumping data for table 'specs'
#

INSERT INTO specs VALUES (30,1,1,40,1,5);

